Index: /trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specIR.F	(revision 1529)
@@ -1,3 +1,3 @@
-      SUBROUTINE iniwrite_specIR(nid,idayref)
+      SUBROUTINE iniwrite_specIR(nid,idayref,area)
 
       use radinc_h, only: L_NSPECTI
@@ -8,4 +8,6 @@
       USE serre_mod, ONLY: clon,clat,grossismx,grossismy,dzoomx,dzoomy
       USE ener_mod, ONLY: etot0,ptot0,ztot0,stot0,ang0
+      USE regular_lonlat_mod, ONLY: lon_reg, lat_reg
+      USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev
 
       implicit none
@@ -27,9 +29,5 @@
 c   -------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
-#include "netcdf.inc"
-!#include"dimphys.h"
+      include "netcdf.inc"
 
 c   Arguments:
@@ -38,4 +36,5 @@
       integer,intent(in) :: nid        ! NetCDF file ID
       INTEGER*4,intent(in) :: idayref  ! date (initial date for this run)
+      real,intent(in) :: area(nbp_lon+1,nbp_lat) ! mesh area (m2)
 
 c   Local:
@@ -45,4 +44,5 @@
       REAL tab_cntrl(length) ! run parameters are stored in this array
       INTEGER ierr
+      REAl :: lon_reg_ext(nbp_lon+1) ! extended longitudes
 
       integer :: nvarid,idim_index,idim_rlonu,idim_rlonv
@@ -57,7 +57,7 @@
          tab_cntrl(l)=0.
       ENDDO
-      tab_cntrl(1)  = FLOAT(iim)
-      tab_cntrl(2)  = FLOAT(jjm)
-      tab_cntrl(3)  = FLOAT(llm)
+      tab_cntrl(1)  = FLOAT(nbp_lon)
+      tab_cntrl(2)  = FLOAT(nbp_lat-1)
+      tab_cntrl(3)  = FLOAT(nbp_lev)
       tab_cntrl(4)  = FLOAT(idayref)
       tab_cntrl(5)  = rad
@@ -102,6 +102,6 @@
 
       ierr = NF_DEF_DIM (nid, "index", length, idim_index)
-      ierr = NF_DEF_DIM (nid, "latitude", jjp1, idim_rlatu)
-      ierr = NF_DEF_DIM (nid, "longitude", iip1, idim_rlonv)
+      ierr = NF_DEF_DIM (nid, "latitude", nbp_lat, idim_rlatu)
+      ierr = NF_DEF_DIM (nid, "longitude", nbp_lon+1, idim_rlonv)
       ierr = NF_DEF_DIM (nid, "IR Wavenumber",L_NSPECTI,idim_bandsIR)
 
@@ -141,10 +141,14 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatu/pi*180)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatu/pi*180)
-#endif
-c
-c --------------------------
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lat_reg/pi*180)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,lat_reg/pi*180)
+#endif
+c
+c --------------------------
+      lon_reg_ext(1:nbp_lon)=lon_reg(1:nbp_lon)
+      !add extra redundant point (180 degrees, since lon_reg starts at -180
+      lon_reg_ext(nbp_lon+1)=-lon_reg_ext(1)
+      
       ierr = NF_REDEF (nid)
 #ifdef NC_DOUBLE
@@ -158,7 +162,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonv/pi*180)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlonv/pi*180)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lon_reg_ext/pi*180)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,lon_reg_ext/pi*180)
 #endif
 c
@@ -172,8 +176,8 @@
 #ifdef NC_DOUBLE
       ierr=NF_DEF_VAR(nid,"IR Wavenumber",NF_DOUBLE,1,
-     .				idim_bandsIR,nvarid)
+     .                                idim_bandsIR,nvarid)
 #else
       ierr=NF_DEF_VAR(nid,"IR Wavenumber",NF_FLOAT,1,
-     .				idim_bandsIR,nvarid)
+     .                                idim_bandsIR,nvarid)
 #endif
       ierr=NF_PUT_ATT_TEXT (nid,nvarid,"long_name", 34,
@@ -196,8 +200,8 @@
 #ifdef NC_DOUBLE
       ierr=NF_DEF_VAR(nid,"IR Bandwidth",NF_DOUBLE,1,
-     .				idim_bandsIR,nvarid)
+     .                                idim_bandsIR,nvarid)
 #else
       ierr=NF_DEF_VAR(nid,"IR Bandwidth",NF_FLOAT,1,
-     .				idim_bandsIR,nvarid)
+     .                                idim_bandsIR,nvarid)
 #endif
       ierr=NF_PUT_ATT_TEXT (nid,nvarid,"long_name", 25,
@@ -230,7 +234,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,aire)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,aire)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,area)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,area)
 #endif
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/iniwrite_specVI.F	(revision 1529)
@@ -1,7 +1,6 @@
-      SUBROUTINE iniwrite_specVI(nid,idayref)
+      SUBROUTINE iniwrite_specVI(nid,idayref,area)
 
       use radinc_h, only: L_NSPECTV
       use radcommon_h, only: WNOV,DWNV
-      use comsoil_h
       use comcstfi_mod, only: rad, omeg, g, mugaz, rcp, pi
       use time_phylmdz_mod, only: daysec, dtphys
@@ -9,4 +8,6 @@
       USE serre_mod, ONLY: clon,clat,grossismx,grossismy,dzoomx,dzoomy
       USE ener_mod, ONLY: etot0,ptot0,ztot0,stot0,ang0
+      USE regular_lonlat_mod, ONLY: lon_reg, lat_reg
+      USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev
 
       implicit none
@@ -28,15 +29,12 @@
 c   -------------
 
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
-#include "netcdf.inc"
-!#include"dimphys.h"
+      include "netcdf.inc"
 
 c   Arguments:
 c   ----------
 
-      integer nid        ! NetCDF file ID
-      INTEGER*4 idayref  ! date (initial date for this run)
+      integer,intent(in) :: nid        ! NetCDF file ID
+      INTEGER*4,INTENT(IN) :: idayref  ! date (initial date for this run)
+      real,intent(in) :: area(nbp_lon+1,nbp_lat) ! mesh area (m2)
 
 c   Local:
@@ -46,4 +44,5 @@
       REAL tab_cntrl(length) ! run parameters are stored in this array
       INTEGER ierr
+      REAl :: lon_reg_ext(nbp_lon+1) ! extended longitudes
 
       integer :: nvarid,idim_index,idim_rlonu,idim_rlonv
@@ -58,7 +57,7 @@
          tab_cntrl(l)=0.
       ENDDO
-      tab_cntrl(1)  = FLOAT(iim)
-      tab_cntrl(2)  = FLOAT(jjm)
-      tab_cntrl(3)  = FLOAT(llm)
+      tab_cntrl(1)  = FLOAT(nbp_lon)
+      tab_cntrl(2)  = FLOAT(nbp_lat-1)
+      tab_cntrl(3)  = FLOAT(nbp_lev)
       tab_cntrl(4)  = FLOAT(idayref)
       tab_cntrl(5)  = rad
@@ -103,6 +102,6 @@
 
       ierr = NF_DEF_DIM (nid, "index", length, idim_index)
-      ierr = NF_DEF_DIM (nid, "latitude", jjp1, idim_rlatu)
-      ierr = NF_DEF_DIM (nid, "longitude", iip1, idim_rlonv)
+      ierr = NF_DEF_DIM (nid, "latitude", nbp_lat, idim_rlatu)
+      ierr = NF_DEF_DIM (nid, "longitude", nbp_lon+1, idim_rlonv)
       ierr = NF_DEF_DIM (nid, "VI Wavenumber",L_NSPECTV,idim_bandsVI)
 
@@ -141,10 +140,14 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatu/pi*180)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatu/pi*180)
-#endif
-c
-c --------------------------
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lat_reg/pi*180)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,lat_reg/pi*180)
+#endif
+c
+c --------------------------
+      lon_reg_ext(1:nbp_lon)=lon_reg(1:nbp_lon)
+      !add extra redundant point (180 degrees, since lon_reg starts at -180
+      lon_reg_ext(nbp_lon+1)=-lon_reg_ext(1)
+
       ierr = NF_REDEF (nid)
 #ifdef NC_DOUBLE
@@ -158,7 +161,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonv/pi*180)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlonv/pi*180)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,lon_reg_ext/pi*180)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,lon_reg_ext/pi*180)
 #endif
 c
@@ -172,8 +175,8 @@
 #ifdef NC_DOUBLE
       ierr=NF_DEF_VAR(nid,"VI Wavenumber",NF_DOUBLE,1,
-     .				idim_bandsVI,nvarid)
+     .                                idim_bandsVI,nvarid)
 #else
       ierr=NF_DEF_VAR(nid,"VI Wavenumber",NF_FLOAT,1,
-     .				idim_bandsVI,nvarid)
+     .                                idim_bandsVI,nvarid)
 #endif
       ierr=NF_PUT_ATT_TEXT (nid,nvarid,"long_name", 33,
@@ -197,8 +200,8 @@
 #ifdef NC_DOUBLE
       ierr=NF_DEF_VAR(nid,"VI Bandwidth",NF_DOUBLE,1,
-     .				idim_bandsVI,nvarid)
+     .                                idim_bandsVI,nvarid)
 #else
       ierr=NF_DEF_VAR(nid,"VI Bandwidth",NF_FLOAT,1,
-     .				idim_bandsVI,nvarid)
+     .                                idim_bandsVI,nvarid)
 #endif
       ierr=NF_PUT_ATT_TEXT (nid,nvarid,"long_name", 24,
@@ -231,7 +234,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,aire)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,aire)
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,area)
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,area)
 #endif
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90	(revision 1529)
@@ -1,3 +1,3 @@
-subroutine iniwritesoil(nid,ngrid)
+subroutine iniwritesoil(nid,ngrid,inertia,area)
 
 ! initialization routine for 'writediagoil'. Here we create/define
@@ -5,17 +5,18 @@
 ! (time-independent) parameters.
 
-use comsoil_h, only: mlayer, inertiedat, nsoilmx
-use comcstfi_mod, only: pi
+use comsoil_h, only: mlayer, nsoilmx
+USE comcstfi_mod, only: pi
+USE regular_lonlat_mod, ONLY: lon_reg, lat_reg
+use mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
 
 implicit none
 
-#include"dimensions.h"
-#include"paramet.h"
-#include"comgeom.h"
-#include"netcdf.inc"
+include"netcdf.inc"
 
 ! Arguments:
 integer,intent(in) :: ngrid
 integer,intent(in) :: nid ! NetCDF output file ID
+real,intent(in) :: inertia(nbp_lon+1,nbp_lat,nsoilmx)
+real,intent(in) :: area(nbp_lon+1,nbp_lat) ! mesh area (m2)
 
 ! Local variables:
@@ -30,6 +31,7 @@
 integer,dimension(3) :: dimids ! to store IDs of dimensions of a variable
 character(len=60) :: text ! to store some text
-real,dimension(iip1,jjp1,nsoilmx) :: data3 ! to store 3D data
+real,dimension(nbp_lon+1,nbp_lat,nsoilmx) :: data3 ! to store 3D data
 integer :: i,j,l,ig0
+real :: lon_reg_ext(nbp_lon+1) ! extended longitudes
 
 ! 1. Define the dimensions
@@ -38,16 +40,14 @@
 
 ! Define the dimensions
-ierr=NF_DEF_DIM(nid,"longitude",iip1,idim_rlonv)
-! iip1 known from paramet.h
+ierr=NF_DEF_DIM(nid,"longitude",nbp_lon+1,idim_rlonv)
 if (ierr.ne.NF_NOERR) then
   write(*,*)"iniwritesoil: Error, could not define longitude dimension"
 endif
-ierr=NF_DEF_DIM(nid,"latitude",jjp1,idim_rlatu)
-! jjp1 known from paramet.h
+ierr=NF_DEF_DIM(nid,"latitude",nbp_lat,idim_rlatu)
 if (ierr.ne.NF_NOERR) then
   write(*,*)"iniwritesoil: Error, could not define latitude dimension"
 endif
 ierr=NF_DEF_DIM(nid,"depth",nsoilmx,idim_depth)
-! nsoilmx known from dimphys.h
+! nsoilmx known from comsoil_h
 if (ierr.ne.NF_NOERR) then
   write(*,*)"iniwritesoil: Error, could not define depth dimension"
@@ -81,13 +81,17 @@
 ierr=NF_PUT_ATT_TEXT(nid,varid,"units",len_trim(text),text)
 
+lon_reg_ext(1:nbp_lon)=lon_reg(1:nbp_lon)
+!add extra redundant point (180 degrees, since lon_reg starts at -180
+lon_reg_ext(nbp_lon+1)=-lon_reg_ext(1)
+
 ! Write longitude to file
 ierr=NF_ENDDEF(nid) ! switch out of NetCDF define mode
 ! Write
 #ifdef NC_DOUBLE
-ierr=NF_PUT_VAR_DOUBLE(nid,varid,rlonv*(180./pi))
-#else
-ierr=NF_PUT_VAR_REAL(nid,varid,rlonv*(180./pi))
-#endif
-! Note: rlonv is known from comgeom.h
+ierr=NF_PUT_VAR_DOUBLE(nid,varid,lon_reg_ext*(180./pi))
+#else
+ierr=NF_PUT_VAR_REAL(nid,varid,lon_reg_ext*(180./pi))
+#endif
+! Note: rlonv is known from comgeom.h and pi from comcstfi.h
 if (ierr.ne.NF_NOERR) then
   write(*,*)"iniwritesoil: Error, could not write longitude variable"
@@ -117,9 +121,8 @@
 ! Write
 #ifdef NC_DOUBLE
-ierr=NF_PUT_VAR_DOUBLE(nid,varid,rlatu*(180./pi))
-#else
-ierr=NF_PUT_VAR_REAL(nid,varid,rlatu*(180./pi))
-#endif
-! Note: rlatu is known from comgeom.h
+ierr=NF_PUT_VAR_DOUBLE(nid,varid,lat_reg*(180./pi))
+#else
+ierr=NF_PUT_VAR_REAL(nid,varid,lat_reg*(180./pi))
+#endif
 if (ierr.ne.NF_NOERR) then
   write(*,*)"iniwritesoil: Error, could not write longitude variable"
@@ -209,9 +212,8 @@
 ! Write
 #ifdef NC_DOUBLE
-ierr=NF_PUT_VAR_DOUBLE(nid,varid,aire)
-#else
-ierr=NF_PUT_VAR_REAL(nid,varid,aire)
-#endif
-! Note: aire is known from comgeom.h
+ierr=NF_PUT_VAR_DOUBLE(nid,varid,area)
+#else
+ierr=NF_PUT_VAR_REAL(nid,varid,area)
+#endif
 if (ierr.ne.NF_NOERR) then
   write(*,*)"iniwritesoil: Error, could not write area variable"
@@ -240,30 +242,11 @@
 ierr=NF_PUT_ATT_TEXT(nid,varid,"units",len_trim(text),text)
 
-! Recast data along 'dynamics' grid
-! Note: inertiedat is known from comsoil_h
-
-do l=1,nsoilmx
-  ! handle the poles
-  do i=1,iip1
-    data3(i,1,l)=inertiedat(1,l)
-    data3(i,jjp1,l)=inertiedat(ngrid,l)
-  enddo
-  ! rest of the grid
-  do j=2,jjm
-    ig0=1+(j-2)*iim
-    do i=1,iim
-      data3(i,j,l)=inertiedat(ig0+i,l)
-    enddo
-    data3(iip1,j,l)=data3(1,j,l) ! extra (modulo) longitude
-  enddo
-enddo ! of do l=1,nsoilmx
-
 ! Write data2 to file
 ierr=NF_ENDDEF(nid) ! switch out of NetCDF define mode
 ! Write
 #ifdef NC_DOUBLE
-ierr=NF_PUT_VAR_DOUBLE(nid,varid,data3)
-#else
-ierr=NF_PUT_VAR_REAL(nid,varid,data3)
+ierr=NF_PUT_VAR_DOUBLE(nid,varid,inertia)
+#else
+ierr=NF_PUT_VAR_REAL(nid,varid,inertia)
 #endif
 if (ierr.ne.NF_NOERR) then
Index: /trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/mass_redistribution.F90	(revision 1529)
@@ -1,3 +1,3 @@
-      SUBROUTINE mass_redistribution(ngrid,nlayer,nq,ptimestep,   &
+SUBROUTINE mass_redistribution(ngrid,nlayer,nq,ptimestep,   &
                        rnat,pcapcal,pplay,pplev,pt,ptsrf,pq,pqs,     &
 		       pu,pv,pdt,pdtsrf,pdq,pdu,pdv,pdmassmr,  &
@@ -224,7 +224,7 @@
 !        Van Leer scheme:
          w(1:nlayer+1)=-zmflux(1:nlayer+1)*ptimestep
-         call vl1d(zzt,2.,zzmass,w,ztm) 
-         call vl1d(zzu ,2.,zzmass,w,zum) 
-         call vl1d(zzv ,2.,zzmass,w,zvm) 
+         call vl1d(nlayer,zzt,2.,zzmass,w,ztm) 
+         call vl1d(nlayer,zzu,2.,zzmass,w,zum) 
+         call vl1d(nlayer,zzv,2.,zzmass,w,zvm) 
          do iq=1,nq
            zq1(1:nlayer)=zzq(1:nlayer,iq)
@@ -232,5 +232,5 @@
 !		print*,iq
 !		print*,zq1
-           call vl1d(zq1,2.,zzmass,w,zqm1)
+           call vl1d(nlayer,zq1,2.,zzmass,w,zqm1)
            do l=2,nlayer
               zzq(l,iq)=zq1(l)
@@ -281,11 +281,8 @@
       END DO  ! loop on ig 
 
-      return
-      end
-
-
+CONTAINS
 
 ! *****************************************************************
-      SUBROUTINE vl1d(q,pente_max,zzmass,w,qm)
+      SUBROUTINE vl1d(llm,q,pente_max,zzmass,w,qm)
 !
 !    
@@ -299,10 +296,10 @@
 !
 !   --------------------------------------------------------------------
+      
       IMPLICIT NONE
-
-#include "dimensions.h"
 
 !   Arguments:
 !   ----------
+      integer,intent(in) :: llm
       real zzmass(llm),pente_max
       REAL q(llm),qm(llm+1)
@@ -406,4 +403,5 @@
 !         end if
 
-      return
-      end
+       END SUBROUTINE vl1d
+
+END SUBROUTINE mass_redistribution
Index: /trunk/LMDZ.GENERIC/libf/phystd/mkstat.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/mkstat.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/mkstat.F90	(revision 1529)
@@ -10,24 +10,22 @@
 !  Yann W. july 2003
 
+use statto_mod, only: istime,count
 use mod_phys_lmdz_para, only : is_master
-use statto_mod, only: istime,count
+use mod_grid_phy_lmdz, only : nbp_lon, nbp_lat, nbp_lev
 
 implicit none
 
-#include "dimensions.h"
-#include "netcdf.inc"
+include "netcdf.inc"
 
-integer,parameter :: iip1=iim+1
-integer,parameter :: jjp1=jjm+1
 integer :: ierr,nid,nbvar,i,ndims,lt,nvarid
 integer, dimension(4) :: id,varid,start,size
 integer, dimension(5) :: dimids
 character (len=50) :: name,nameout,units,title
-real, dimension(iip1,jjp1,llm) :: sum3d,square3d,mean3d,sd3d
-real, dimension(iip1,jjp1) :: sum2d,square2d,mean2d,sd2d
+real, dimension(nbp_lon+1,nbp_lat,nbp_lev) :: sum3d,square3d,mean3d,sd3d
+real, dimension(nbp_lon+1,nbp_lat) :: sum2d,square2d,mean2d,sd2d
 real, dimension(istime) :: time
-real, dimension(jjp1) :: lat
-real, dimension(iip1) :: lon
-real, dimension(llm) :: alt
+real, dimension(nbp_lat) :: lat
+real, dimension(nbp_lon+1) :: lon
+real, dimension(nbp_lev) :: alt
 logical :: lcopy=.true.
 !integer :: latid,lonid,altid,timeid
@@ -35,9 +33,9 @@
 !integer, dimension(4) :: dimout
 
+! Incrementation of count for the last step, which is not done in wstats
+count(istime)=count(istime)+1
+
 if (is_master) then
 ! only the master needs do this
-
-! Incrementation of count for the last step, which is not done in wstats
-count(istime)=count(istime)+1
 
 ierr = NF_OPEN("stats.nc",NF_WRITE,nid)
@@ -107,5 +105,5 @@
 !      dimout(4)=timeid
 
-      size=(/iip1,jjp1,llm,1/)
+      size=(/nbp_lon+1,nbp_lat,nbp_lev,1/)
       do lt=1,istime
          start=(/1,1,1,lt/)
@@ -137,5 +135,5 @@
 !      dimout(3)=timeid
 
-      size=(/iip1,jjp1,1,0/)
+      size=(/nbp_lon+1,nbp_lat,1,0/)
       do lt=1,istime
          start=(/1,1,lt,0/)
Index: /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1529)
@@ -26,6 +26,8 @@
       use time_phylmdz_mod, only: ecritphy, iphysiq, nday
       use phyredem, only: physdem0, physdem1
-      use slab_ice_h
+      use slab_ice_h, only: capcalocean, capcalseaice,capcalsno, &
+                            noceanmx
       use ocean_slab_mod, only :ocean_slab_init, ocean_slab_ice, &
+                                ini_surf_heat_transp_mod, &
                                 ocean_slab_get_vars,ocean_slab_final
       use surf_heat_transp_mod,only :init_masquv
@@ -558,4 +560,6 @@
                                 sea_ice, pctsrf_sic)
 
+           call ini_surf_heat_transp_mod()
+           
            knindex(:) = 0
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/radcommon_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/radcommon_h.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/radcommon_h.F90	(revision 1529)
@@ -1,5 +1,5 @@
-      module radcommon_h
-
-      use radinc_h
+module radcommon_h
+      use radinc_h, only: L_NSPECTI, L_NSPECTV, L_NGAUSS, NTstar, NTstop, &
+                          naerkind, nsizemax
       implicit none
 
@@ -121,13 +121,14 @@
       REAL :: omegaREFir(naerkind,nsizemax)
 
-      REAL tstellar ! Stellar brightness temperature (SW)
+      REAL,SAVE :: tstellar ! Stellar brightness temperature (SW)
 
-      real*8 planckir(L_NSPECTI,NTstop-NTstar+1)
+      real*8,save :: planckir(L_NSPECTI,NTstop-NTstar+1)
 
-      real*8 PTOP, TAUREF(L_LEVELS+1)
+      real*8,save :: PTOP
+      real*8,save,allocatable :: TAUREF(:)
 
-      real*8, parameter :: UBARI = 0.5D0
+      real*8,parameter :: UBARI = 0.5D0
 
-      real*8 gweight(L_NGAUSS)
+      real*8,save :: gweight(L_NGAUSS)
 !$OMP THREADPRIVATE(QREFvis,QREFir,omegaREFvis,omegaREFir,& 	! gweight read by master in sugas_corrk
 		!$OMP tstellar,planckir,PTOP,TAUREF)
@@ -144,16 +145,24 @@
       real*8, parameter :: grav = 6.672E-11
 
-      real*8 Cmk
-      save Cmk
-      real*8 glat_ig
-      save glat_ig
+      real*8,save :: Cmk
+      real*8,save :: glat_ig
 !$OMP THREADPRIVATE(Cmk,glat_ig)
 
       ! extinction of incoming sunlight (Saturn's rings, eclipses, etc...)
-      REAL, DIMENSION(:), ALLOCATABLE :: eclipse
+      REAL, DIMENSION(:), ALLOCATABLE ,SAVE :: eclipse
 
       !Latitude-dependent gravity
-      REAL, DIMENSION(:), ALLOCATABLE :: glat
+      REAL, DIMENSION(:), ALLOCATABLE , SAVE :: glat
 !$OMP THREADPRIVATE(glat,eclipse)
 
-      end module radcommon_h
+contains
+
+      subroutine ini_radcommon_h
+      use radinc_h, only: L_LEVELS
+      implicit none
+      
+        allocate(TAUREF(L_LEVELS+1))
+      
+      end subroutine ini_radcommon_h
+
+end module radcommon_h
Index: /trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90	(revision 1529)
@@ -8,7 +8,7 @@
 !     water cloud optical properties
 
-      use callkeys_mod, only: radfixed,Nmix_co2,			&
-		pres_bottom_tropo,pres_top_tropo,size_tropo,	&
-		pres_bottom_strato,size_strato
+      use callkeys_mod, only: radfixed,Nmix_co2,                    &
+                pres_bottom_tropo,pres_top_tropo,size_tropo,        &
+                pres_bottom_strato,size_strato
       
       real, save ::  rad_h2o
@@ -21,5 +21,5 @@
 
 
-      contains
+contains
 
 
@@ -38,10 +38,7 @@
       use ioipsl_getin_p_mod, only: getin_p
       use radinc_h, only: naerkind
-      use aerosol_mod
-!      USE tracer_h
-      Implicit none
-
-!      include "dimensions.h"
-!      include "dimphys.h"
+      use aerosol_mod, only: iaero_back2lay, iaero_co2, iaero_dust, &
+                             iaero_h2o, iaero_h2so4
+      Implicit none
 
       integer,intent(in) :: ngrid
@@ -81,6 +78,6 @@
                nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
             endif
-	    
-	    if(iaer.eq.iaero_back2lay)then ! Two-layer aerosols
+            
+            if(iaer.eq.iaero_back2lay)then ! Two-layer aerosols
                reffrad(1:ngrid,1:nlayer,iaer) = 2.e-6
                nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
@@ -101,15 +98,15 @@
          if (radfixed) then
 
-	    write(*,*)"radius of H2O water particles:"
+            write(*,*)"radius of H2O water particles:"
             rad_h2o=13. ! default value
             call getin_p("rad_h2o",rad_h2o)
             write(*,*)" rad_h2o = ",rad_h2o
 
-	    write(*,*)"radius of H2O ice particles:"
+            write(*,*)"radius of H2O ice particles:"
             rad_h2o_ice=35. ! default value
             call getin_p("rad_h2o_ice",rad_h2o_ice)
             write(*,*)" rad_h2o_ice = ",rad_h2o_ice
 
-	 else
+         else
 
             write(*,*)"Number mixing ratio of H2O water particles:"
@@ -122,5 +119,5 @@
             call getin_p("Nmix_h2o_ice",Nmix_h2o_ice)
             write(*,*)" Nmix_h2o_ice = ",Nmix_h2o_ice
-	 endif
+         endif
 
       print*,'exit su_aer_radii'
@@ -173,10 +170,10 @@
                zfice = 1.0 - (pt(ig,l)-T_h2O_ice_clouds) / (T_h2O_ice_liq-T_h2O_ice_clouds)
                zfice = MIN(MAX(zfice,0.0),1.0)
-	       zrad_liq  = CBRT( 3*pq(ig,l)/(4*Nmix_h2o*pi*rhowater) )
-	       zrad_ice  = CBRT( 3*pq(ig,l)/(4*Nmix_h2o_ice*pi*rhowaterice) )
+               zrad_liq  = CBRT( 3*pq(ig,l)/(4*Nmix_h2o*pi*rhowater) )
+               zrad_ice  = CBRT( 3*pq(ig,l)/(4*Nmix_h2o_ice*pi*rhowaterice) )
                nueffrad(ig,l) = coef_chaud * (1.-zfice) + coef_froid * zfice
                zrad = zrad_liq * (1.-zfice) + zrad_ice * zfice
 
-	       reffrad(ig,l) = min(max(zrad,1.e-6),1000.e-6)
+               reffrad(ig,l) = min(max(zrad,1.e-6),1000.e-6)
                enddo
             enddo      
@@ -213,16 +210,16 @@
 
       if (radfixed) then
-	 reffliq(1:ngrid,1:nlayer)= rad_h2o
-	 reffice(1:ngrid,1:nlayer)= rad_h2o_ice
+         reffliq(1:ngrid,1:nlayer)= rad_h2o
+         reffice(1:ngrid,1:nlayer)= rad_h2o_ice
       else
-	 do k=1,nlayer
-	   do i=1,ngrid
-	     reffliq(i,k) = CBRT(3*pql(i,k)/(4*Nmix_h2o*pi*rhowater))
-	     reffliq(i,k) = min(max(reffliq(i,k),1.e-6),1000.e-6)
-	   
-	     reffice(i,k) = CBRT(3*pql(i,k)/(4*Nmix_h2o_ice*pi*rhowaterice))
-	     reffice(i,k) = min(max(reffice(i,k),1.e-6),1000.e-6)
-	   enddo
-	 enddo
+         do k=1,nlayer
+           do i=1,ngrid
+             reffliq(i,k) = CBRT(3*pql(i,k)/(4*Nmix_h2o*pi*rhowater))
+             reffliq(i,k) = min(max(reffliq(i,k),1.e-6),1000.e-6)
+           
+             reffice(i,k) = CBRT(3*pql(i,k)/(4*Nmix_h2o_ice*pi*rhowaterice))
+             reffice(i,k) = min(max(reffice(i,k),1.e-6),1000.e-6)
+           enddo
+         enddo
       endif
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/radinc_h.F90	(revision 1529)
@@ -1,9 +1,8 @@
-      module radinc_h
+module radinc_h
 
-      implicit none
+  implicit none
 
-#include "dimensions.h"
-#include "bands.h"
-#include "scatterers.h"
+  include "bands.h"
+  include "scatterers.h"
 
 !======================================================================
@@ -57,7 +56,8 @@
 !----------------------------------------------------------------------
 
-      integer, parameter :: L_NLAYRAD  = llm
-      integer, parameter :: L_LEVELS   = 2*(llm-1)+3
-      integer, parameter :: L_NLEVRAD  = llm+1
+      integer,save :: L_NLAYRAD  ! = nbp_lev ! set by ini_radinc_h
+      integer,save :: L_LEVELS   ! = 2*(nbp_lev-1)+3 ! set by ini_radinc_h
+      integer,save :: L_NLEVRAD  ! = nbp_lev+1 ! set by ini_radinc_h
+!$OMP THREADPRIVATE(L_NLAYRAD,L_LEVELS,L_NLEVRAD)
 
       ! These are set in sugas_corrk
@@ -96,3 +96,16 @@
 !$OMP THREADPRIVATE(banddir)
 
-      end module radinc_h
+contains
+
+  subroutine ini_radinc_h(nbp_lev)
+  ! Initialize module variables
+  implicit none
+  integer,intent(in) :: nbp_lev
+  
+  L_NLAYRAD = nbp_lev
+  L_LEVELS = 2*(nbp_lev-1)+3
+  L_NLEVRAD = nbp_lev+1
+  
+  end subroutine
+
+end module radinc_h
Index: /trunk/LMDZ.GENERIC/libf/phystd/soil.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 1529)
@@ -20,8 +20,4 @@
 !        heat capacity are commons in comsoil.h
 !-----------------------------------------------------------------------
-
-!      include "dimensions.h"
-!      include "dimphys.h"
-
 
 c-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/suaer_corrk.F90	(revision 1529)
@@ -2,5 +2,5 @@
 
       ! inputs
-      use radinc_h,    only: L_NSPECTI,L_NSPECTV,nsizemax,iim,jjm,naerkind
+      use radinc_h,    only: L_NSPECTI,L_NSPECTV,nsizemax,naerkind
       use radcommon_h, only: blamv,blami,lamrefir,lamrefvis
       use datafile_mod, only: datadir, aerdir
